
      subroutine extsym_to_gsas(maxpts,maxrefs,nrefs,h,k,l,Iout,
     - x_bragg,fwhm,lor,npts,tof,yout)

      USE DFPORT

      implicit none

      integer maxpts,maxhist,maxatoms,maxrefs
      parameter (maxhist=10)
      parameter (maxatoms=20)

      integer sysreturn,histogram,i,out_histogram,no_histogram
      character*80 file,syscall,gsasdir,cmd,cmd2

      character*12 peak_s0,peak_s1,peak_s2,peak_s3,difparam_s,
     - back_s0,back_s1,back_s2,back_s3,back_s4,back_s5,
     - back_s6,back_s7,back_s8,back_s9,hst_range,
     - hscale_s,angle_s,rad_type*3

      real cellvol,peak(maxhist,12),bvars(maxhist,36),
     - difc(maxhist),difa(maxhist),zero(maxhist),
     - angle(maxhist),hscale(maxhist),l2,minx(maxhist),maxx(maxhist)
      integer ptype(maxhist),bnovars(maxhist),btype(maxhist),missed

      integer dummy1,dummy2,npts,page,recno,loop,loop2,outnpts
      integer h(maxrefs),k(maxrefs),l(maxrefs),nrefs,refno,dummyint,
     - totrefs
      real    fwhm_tof2,get_tof,fwhm(maxrefs),x_bragg(maxrefs)
      real    multi(maxrefs),dp(maxrefs),fobs(maxrefs),Iout(maxrefs)
      real  lor(maxrefs),tof(maxpts),yout(maxpts),dmin
      real minh,maxh,mink,maxk,minl,maxl,dh,dk,dl
      integer atomnum,gsasatomnum,numgsasatoms
      real xfac(maxatoms,9),pi,deg2rad
      character*80 buffer,dummy_c*1,exten*4,atomname(maxatoms)*2,
     -gsasatomtype(maxatoms)*2
      logical run,looping,file_exists

      pi=acos(-1.0)
      deg2rad=pi/180.0

      file_exists=.false.

      file='ZrW2O8_300K'
      out_histogram=2
      dmin=0.55
      minh=-20
      maxh=20
      dh=1.0
      mink=-20
      maxk=20
      dk=1.0
      minl=-20
      maxl=20
      dl=1.0

      gsasdir=''
      call getarg(1,gsasdir)
      if (gsasdir.eq.'') then
      gsasdir='C:\gsas\exe\'
      else
      i=len(gsasdir)
      do while(gsasdir(i:i).eq.' ')
      i=i-1
      enddo
      gsasdir=gsasdir(1:i)//"\"
      endif

      Write(*,*) 'The gsas directory is ',gsasdir

      write(*,*) 'Please enter the GSAS filename (no .EXP)'
      read(*,'(a)',err=1001) file
      write(*,*) 'Please enter the histogram required'
      read(*,*,err=1001) out_histogram

      if (out_histogram.le.9) then
      write(exten,'(a3,i1)') '.P0',out_histogram
      else
      write(exten,'(a2,i2)') '.P',out_histogram
      endif

      call check_file(file_exists,file,exten)

      if(.not.file_exists) then

      cmd='powpref'
      call add_string(cmd2,gsasdir,cmd)

      call add_string_space(syscall,cmd2,file)
      sysreturn=SYSTEM(syscall)


      cmd='genles'
      call add_string(cmd2,gsasdir,cmd)

      call add_string_space(syscall,cmd2,file)
      sysreturn=SYSTEM(syscall)
      endif

********Produce hstdmp of required histogram

      open(10,file='get_bragg_tempy.temp')
      write(10,'(a)') 'L'
      write(10,*)  out_histogram
      write(10,*) '0'
      close(10)

****  Keep a copy of the .LST file
      call add_string(cmd,file,'.LST')
      call add_string_space(cmd2,'rename',cmd)
      call add_string_space(syscall,cmd2,'get_bragg_tempy.keep')
      sysreturn=SYSTEM(syscall)

      cmd='< get_bragg_tempy.temp'
      call add_string_space(cmd2,file,cmd)
      cmd='hstdmp'
      call add_string(syscall,gsasdir,cmd)
      cmd=syscall
      call add_string_space(syscall,cmd,cmd2)
      sysreturn=SYSTEM(syscall)

****  Copy dumped hst to file
      sysreturn=SYSTEM('del/q get_bragg_tempy.hst')
      call add_string(cmd,file,'.LST')
      call add_string_space(cmd2,'rename',cmd)
      call add_string_space(syscall,cmd2,'get_bragg_tempy.hst')
      sysreturn=SYSTEM(syscall)

****  Restore .LST file
      call add_string(cmd,file,'.LST')
      call add_string_space(syscall,'rename get_bragg_tempy.keep',cmd)
      sysreturn=SYSTEM(syscall)

c      sysreturn=SYSTEM('del/q get_bragg_tempy.temp')


      write(*,*) sysreturn

********Produce reflist of required histogram

      open(10,file='get_bragg_tempy.temp')
      write(10,*)  out_histogram
      write(10,'(a)') 'M'
      write(10,*) '0'
      close(10)

****  Keep a copy of the .LST file
      call add_string(cmd,file,'.LST')
      call add_string_space(cmd2,'rename',cmd)
      call add_string_space(syscall,cmd2,'get_bragg_tempy.keep')
      sysreturn=SYSTEM(syscall)

      cmd='< get_bragg_tempy.temp'
      call add_string_space(cmd2,file,cmd)
      cmd='reflist'
      call add_string(syscall,gsasdir,cmd)
      cmd=syscall
      call add_string_space(syscall,cmd,cmd2)
      sysreturn=SYSTEM(syscall)

****  Copy dumped hst to file
      sysreturn=SYSTEM('del/q get_bragg_tempy.ref')
      call add_string(cmd,file,'.LST')
      call add_string_space(cmd2,'rename',cmd)
      call add_string_space(syscall,cmd2,'get_bragg_tempy.ref')
      sysreturn=SYSTEM(syscall)

****  Restore .LST file
      call add_string(cmd,file,'.LST')
      call add_string_space(syscall,'rename get_bragg_tempy.keep',cmd)
      sysreturn=SYSTEM(syscall)

      write(*,*) sysreturn


***   Extract hstdmp information

      open(11,file='get_bragg_tempy.hst')

      looping=.true.
      do while(looping)
      read(11,'(a)') buffer
      if(buffer(1:6).eq.' RecNo') looping=.false.
      enddo

      page=1
      npts=0
      looping=.true.
      do while(looping)
      read(11,'(a)',end=200) buffer
      if(buffer(1:6).eq.' RecNo') then
      page=page+1
      else
      read(buffer,*,err=100,end=100) recno
       if (recno.eq.npts+1) then
        npts=npts+1
        if (npts.gt.maxpts)
     -   stop 'Sorry maximum number of points exceeded'
c        read(buffer,100) dummy1,dummy_c,tof(npts),yout(npts)
         read(buffer(9:80),*) tof(npts),yout(npts)
         tof(npts)=tof(npts)*1000
       endif
100    continue
      endif
      enddo
c100   format(i6,a2,f9.6,f8.5)

200   write(*,*) '--------------------------------------------->'
      write(*,*) 'Number of points in Bragg profile', npts
      write(*,*)
      close(11)

***   Extract reflist information

      open(11,file='get_bragg_tempy.ref')

      looping=.true.
      do while(looping)
      read(11,'(a)') buffer
      if(buffer(1:6).eq.'  Iref') looping=.false.
      enddo

      page=1
      nrefs=0
      looping=.true.
      do while(looping)
      read(11,'(a)',end=201) buffer
      if(buffer(1:6).eq.' Iref') then
      page=page+1
      else
      read(buffer,*,err=101,end=101) refno
       if(nrefs.eq.0) totrefs=refno
        nrefs=nrefs+1
        if (nrefs.gt.maxpts)
     -   stop 'Sorry maximum number of points exceeded'

         read(buffer(7:9),*) h(nrefs)
         read(buffer(10:12),*) k(nrefs)
         read(buffer(13:15),*) l(nrefs)
         read(buffer(16:80),*) multi(nrefs),
     -   dummyint, dp(nrefs),fobs(nrefs)
         Iout(nrefs)=fobs(nrefs)*multi(nrefs)
       endif
101    continue

      enddo
c100   format(i6,a2,f9.6,f8.5)

201   write(*,*) '--------------------------------------------->'
      write(*,*) 'Number of reflections is', nrefs
      write(*,*)
      close(11)



      rad_type='---'
      no_histogram=0
      call open_read(11,file,'.EXP')
      looping=.true.
      do while(looping)
      read(11,'(a80)',err=250,end=250) buffer

      if(buffer(1:12).eq.' EXPR  NHST ') then
      read(buffer(12:80),*) no_histogram
      looping=.false.
      elseif (buffer(1:12).eq.' EXPR  HTYP1') then
      read(buffer(15:18),'(a3)') rad_type
      endif
      enddo
      close(11)
250   if (no_histogram.eq.0) then
      write(*,*) 'Sorry I cannot find any histograms'
      stop
      else
      write(*,251) no_histogram
      write(*,*)
251   format(' There are ',i1,' histograms in this file')
      endif


      do loop=1,no_histogram

      histogram=loop
      call open_read(11,file,'.EXP')

***** Setup search fields

      write(peak_s0,501) histogram
      write(peak_s1,502) histogram
      write(peak_s2,503) histogram
      write(peak_s3,504) histogram

      write(difparam_s,505) histogram
      write(hscale_s,506) histogram
      write(angle_s,507) histogram
      write(hst_range,518) histogram

      write(back_s0,508) histogram
      write(back_s1,509) histogram
      write(back_s2,510) histogram
      write(back_s3,511) histogram
      write(back_s4,512) histogram
      write(back_s5,513) histogram
      write(back_s6,514) histogram
      write(back_s7,515) histogram
      write(back_s8,516) histogram
      write(back_s9,517) histogram

c      write(*,*) back_s0,back_s2,back_s3,back_s4,back_s5
c      write(*,*) back_s6,back_s7,back_s8,back_s9




501      format('HAP1 ',i1,'PRCF  ')
502      format('HAP1 ',i1,'PRCF 1')
503      format('HAP1 ',i1,'PRCF 2')
504      format('HAP1 ',i1,'PRCF 3')

505      format('HST  ',i1,' ICONS')
506      format('HST  ',i1,'HSCALE')
507      format('HST  ',i1,'BNKPAR')

508      format('HST  ',i1,'BAKGD ')
509      format('HST  ',i1,'BAKGD1')
510      format('HST  ',i1,'BAKGD2')
511      format('HST  ',i1,'BAKGD3')
512      format('HST  ',i1,'BAKGD4')
513      format('HST  ',i1,'BAKGD5')
514      format('HST  ',i1,'BAKGD6')
515      format('HST  ',i1,'BAKGD7')
516      format('HST  ',i1,'BAKGD8')
517      format('HST  ',i1,'BAKGD9')
518      format('HST  ',i1,' TRNGE')



***********************************************


      looping=.true.
      missed=0

      atomnum=0
      gsasatomnum=0

      do while(looping)

      read(11,'(a80)',err=300,end=300) buffer
c      write(*,*) buffer

      if (buffer(2:5).eq.'AFAC'.and.rad_type.eq.'PXC') then
      atomnum=atomnum+1
c      write(*,*)buffer(7:8)
      read(buffer(7:8),'(a2)') atomname(atomnum)
c      write(*,*)buffer(13:75)
      read(buffer(13:75),601) (xfac(atomnum,i),i=1,9)

      do loop2=1,5
      read(11,'(a80)',err=300,end=300) buffer
      enddo
      endif
c601   format(a2,5x,9(f7.0))
601   format(9(f7.0))

      if (buffer(1:12).eq.'CRS1  CELVOL') then
      read(buffer(13:80),*) cellvol
      elseif (buffer(2:12).eq.'EXPR  NATYP') then
      read(buffer(13:80),*) numgsasatoms
      elseif (buffer(2:10).eq.'EXPR ATYP') then
      gsasatomnum=gsasatomnum+1
      read(buffer(15:16),'(a)') gsasatomtype(gsasatomnum)
      elseif (buffer(1:12).eq.peak_s0) then
      read(buffer(13:80),*) ptype(loop)
      elseif (buffer(1:12).eq.peak_s1) then
      read(buffer(13:80),*) (peak(loop,i),i=1,4)
      elseif (buffer(1:12).eq.peak_s2) then
      read(buffer(13:80),*) (peak(loop,4+i),i=1,4)
      elseif (buffer(1:12).eq.peak_s3) then
      read(buffer(13:80),*) (peak(loop,8+i),i=1,2)

      elseif (buffer(1:12).eq.difparam_s) then
      read(buffer(13:80),*) difc(loop),difa(loop),zero(loop)

      elseif (buffer(1:12).eq.back_s0) then
      read(buffer(13:80),*) btype(loop),bnovars(loop)
      elseif (buffer(1:12).eq.back_s1) then
      loop2=min(bnovars(loop),4)
      read(buffer(13:80),*) (bvars(loop,i),i=1,loop2)
      elseif (buffer(1:12).eq.back_s2) then
      loop2=min(bnovars(loop)-4,4)
      read(buffer(13:80),*) (bvars(loop,i),i=5,4+loop2)
      elseif (buffer(1:12).eq.back_s3) then
      loop2=min(bnovars(loop)-8,4)
      read(buffer(13:80),*) (bvars(loop,i),i=9,8+loop2)
      elseif (buffer(1:12).eq.back_s4) then
      loop2=min(bnovars(loop)-12,4)
      read(buffer(13:80),*) (bvars(loop,i),i=13,12+loop2)
      elseif (buffer(1:12).eq.back_s5) then
      loop2=min(bnovars(loop)-16,4)
      read(buffer(13:80),*) (bvars(loop,i),i=17,16+loop2)
      elseif (buffer(1:12).eq.back_s6) then
      loop2=min(bnovars(loop)-20,4)
      read(buffer(13:80),*) (bvars(loop,i),i=21,20+loop2)
      elseif (buffer(1:12).eq.back_s7) then
      loop2=min(bnovars(loop)-24,4)
      read(buffer(13:80),*) (bvars(loop,i),i=25,24+loop2)
      elseif (buffer(1:12).eq.back_s8) then
      loop2=min(bnovars(loop)-28,4)
      read(buffer(13:80),*) (bvars(loop,i),i=29,28+loop2)
      elseif (buffer(1:12).eq.back_s9) then
      loop2=min(bnovars(loop)-32,4)
      read(buffer(13:80),*) (bvars(loop,i),i=33,32+loop2)



      elseif (buffer(1:12).eq.hscale_s) then
      read(buffer(13:80),*) hscale(loop)
      elseif (buffer(1:12).eq.angle_s) then
      read(buffer(13:80),*) l2,angle(loop)
      elseif (buffer(1:12).eq.hst_range) then
      read(buffer(13:80),*) minx(loop),maxx(loop)

      else

      missed=missed+1

      endif

      enddo

300   close(11)
      enddo


********* write out the .xray file  **************

      if(rad_type.eq.'PXC') then
      call open_write(10,file,'.xray')

      if (numgsasatoms.ne.gsasatomnum) write(*,*)
     - 'No. of atom types found not the same as no. of types used'

      write(*,*) gsasatomnum, ' atom types found'
      write(*,*) 'The xray form factor coefficients are:'
      do loop=1,gsasatomnum
      do loop2=1,atomnum
      if (gsasatomtype(loop).eq.atomname(loop2)) then
      write(*,603) atomname(loop2),(xfac(loop2,i),i=1,9)
      write(10,602) atomname(loop2),(xfac(loop2,i),i=1,9)
      endif
      enddo
      enddo

      close(10)
      endif

602   format(a2,2x,9(f8.4))
603   format(a3,2x,9(f8.4))



      loop2=out_histogram

      write(*,*) 'Min and max x are',minx(loop2),maxx(loop2)
      outnpts=0
      do loop=1,npts
        if (tof(loop).ge.minx(loop2).and.tof(loop).ge.minx(loop2))
     -   outnpts=outnpts+1
      enddo

      write(*,*) npts,' points in the histogram'
      write(*,*) outnpts,' points used'

      call open_write(10,file,'.bragg')

      write(10,*) outnpts,out_histogram,hscale(loop2),cellvol
      write(10,'(a12,a40)') 'Time I(obs) ', file
      do loop=1,npts
      if (tof(loop).ge.minx(loop2).and.tof(loop).ge.minx(loop2)) then
        write(10,*) tof(loop),yout(loop)
      endif
      enddo

      close(10)



      write(*,*) 'Radation type ',rad_type

      if(rad_type.eq.'PXC') then

      if (ptype(loop2).eq.2) then
      write(*,*) 'You are using GSAS X-ray peakshape 2'
      write(*,*) 'The RMCProfile code for this is xray2'
      else
      write(*,*) 'You are using GSAS TOF peakshape ',ptype(loop2)
      write(*,*) 'Sorry this gsas peakshape is not supported yet'
      endif


      call open_write(10,file,'.inst')
      write(10,*) no_histogram
      do loop=1,no_histogram
      write(10,*) loop
      write(10,*) difc(loop),zero(loop),difa(loop)

      if(ptype(loop2).eq.2) then
      write(10,'(3(e12.6e2,2x))') peak(loop,1),peak(loop,2),peak(loop,3)
      write(10,'(3(e12.6e2,2x))') peak(loop,4),peak(loop,5),peak(loop,6)
      write(10,'(3(e12.6e2,2x))') peak(loop,7),peak(loop,8),peak(loop,9)
      else
      write(*,*) 'GSAS X-ray peakshape ',ptype(loop2)
      write(*,*) 'Sorry this gsas peakshape is not supported yet'
      endif
      enddo
      close(10)



      else

      if (ptype(loop2).eq.1) then
      write(*,*) 'You are using GSAS TOF peakshape 1'
c      write(*,*) 'The RMCProfile code for this is gsas1'
      elseif (ptype(loop2).eq.2) then
      write(*,*) 'You are using GSAS TOF peakshape 2'
c      write(*,*) 'The RMCProfile code for this is gsas2'
      elseif(ptype(loop2).eq.3) then
      write(*,*) 'You are using GSAS TOF peakshape 3'
c      write(*,*) 'The RMCProfile code for this is gsas3'
      else
      write(*,*) 'You are using GSAS TOF peakshape ',ptype(loop2)
      write(*,*) 'Sorry this gsas peakshape is not supported yet'
      endif


c      call open_write(10,file,'.inst')
c      write(10,*) no_histogram
c      do loop=1,no_histogram
c      write(10,*) loop
c      write(10,*) difc(loop),difa(loop),zero(loop),angle(loop)

      if (ptype(loop2).eq.1) then
      write(10,'(4(e12.6e2,2x))') peak(loop,1),peak(loop,2),peak(loop,3)
     -,peak(loop,4)
      write(10,'(3(e12.6e2,2x))') peak(loop,5),peak(loop,6),
     - peak(loop,7)
       write(10,'(3(e12.6e2,2x))') peak(loop,8)
c,peak(loop,9),peak(loop,10)
      elseif(ptype(loop2).eq.2) then

      loop2=out_histogram

      do loop=1,nrefs
      x_bragg(loop)=get_tof(dp(loop),difc(loop2),difa(loop2),
     -                      zero(loop2))
      fwhm(loop)=fwhm_tof2(dp(loop),peak(loop2,5),peak(loop2,6),
     -           peak(loop2,7),peak(loop2,8),peak(loop2,9),
     -           peak(loop2,10))
      lor(loop)=sin((angle(loop2)*deg2rad)/2)*dp(loop)**4
      enddo

      elseif(ptype(loop2).eq.3) then
      write(10,'(3(e12.6e2,2x))') peak(loop,1),peak(loop,2),peak(loop,3)
      write(10,'(3(e12.6e2,2x))') peak(loop,4),peak(loop,5),peak(loop,6)
      write(10,'(5(e12.6e2,2x))') peak(loop,7),peak(loop,8),peak(loop,9)
     -,peak(loop,10),peak(loop,11)
      else
      write(*,*) 'GSAS peakshape ',ptype(loop2)
      write(*,*) 'Sorry this gsas peakshape is not supported yet'
      endif
c      enddo


      write(*,*) 'End of extsym subroutine'

      endif


      return
      stop 'All files produced happy RMCing'
1001  write(*,*) 'Sorry entry is of the wrong type,'
      write(*,*) 'please try again'
      stop
      end


      subroutine add_string(string,string1,string2)
      implicit none
      integer I,J,K,L,M
      character*(*) string,string1,string2
C We find the relevant part of file.
      I=1
      J=LEN(String1)
      DO K=1,J
        IF(String1(K:K).EQ.' ')THEN
          I=I+1
        ELSE
          GOTO 3000
        ENDIF
      ENDDO
 3000 CONTINUE
      DO K=J,1,-1
        IF(String1(K:K).EQ.' ')THEN
          J=J-1
        ELSE
          GOTO 3010
        ENDIF
      ENDDO
 3010 CONTINUE
      L=1
      M=LEN(String2)
      DO K=1,M
        IF(String2(K:K).EQ.' ')THEN
          L=L+1
        ELSE
          GOTO 3020
        ENDIF
      ENDDO
3020  CONTINUE


      string=string1(I:J)//string2(L:M)
      return
      end

      subroutine add_string_space(string,string1,string2)
      implicit none
      integer I,J,K,L,M
      character*(*) string,string1,string2
C We find the relevant part of file.
      I=1
      J=LEN(String1)
      DO K=1,J
        IF(String1(K:K).EQ.' ')THEN
          I=I+1
        ELSE
          GOTO 3000
        ENDIF
      ENDDO
 3000 CONTINUE
      DO K=J,1,-1
        IF(String1(K:K).EQ.' ')THEN
          J=J-1
        ELSE
          GOTO 3010
        ENDIF
      ENDDO
 3010 CONTINUE
      L=1
      M=LEN(String2)
      DO K=1,M
        IF(String2(K:K).EQ.' ')THEN
          L=L+1
        ELSE
          GOTO 3020
        ENDIF
      ENDDO
3020  CONTINUE


      string=string1(I:J)//' '//string2(L:M)
      return
      end


C     Subroutine open_write opens a file for writing, filling in the
C     supplied extension if none is supplied with the file name.
C     Allows use of system specific facilities of open statement.

      subroutine open_write(unit,file,extension)
      integer unit
      character*(*) file,extension,name*32
C We find the relevant part of file.
      I=1
      J=LEN(FILE)
      DO K=1,J
        IF(FILE(K:K).EQ.' ')THEN
          I=I+1
        ELSE
          GOTO 3000
        ENDIF
      ENDDO
 3000 CONTINUE
      DO K=J,1,-1
        IF(FILE(K:K).EQ.' ')THEN
          J=J-1
        ELSE
          GOTO 3010
        ENDIF
      ENDDO
 3010 CONTINUE
      name=file(I:J)//extension
      open (unit,file=name,STATUS='UNKNOWN')
      end

C     Subroutine open_read opens a file for reading, filling in the
C     supplied extension if none is supplied with the file name.
C     Allows use of system specific facilities of open statement.

      subroutine open_read(unit,file,extension)
      integer unit
      character*(*) file,extension,name*32
C We find the relevant part of file.
      I=1
      J=LEN(FILE)
      DO K=1,J
        IF(FILE(K:K).EQ.' ')THEN
          I=I+1
        ELSE
          GOTO 3000
        ENDIF
      ENDDO
 3000 CONTINUE
      DO K=J,1,-1
        IF(FILE(K:K).EQ.' ')THEN
          J=J-1
        ELSE
          GOTO 3010
        ENDIF
      ENDDO
 3010 CONTINUE
      name=file(I:J)//extension
      open (unit,file=name,status='old')
      end



      subroutine check_file(okay,file,extension)
      logical okay
      character*(*) file,extension,name*32

      okay=.false.
C We find the relevant part of file.
      I=1
      J=LEN(FILE)
      DO K=1,J
        IF(FILE(K:K).EQ.' ')THEN
          I=I+1
        ELSE
          GOTO 3000
        ENDIF
      ENDDO
 3000 CONTINUE
      DO K=J,1,-1
        IF(FILE(K:K).EQ.' ')THEN
          J=J-1
        ELSE
          GOTO 3010
        ENDIF
      ENDDO
 3010 CONTINUE
      name=file(I:J)//extension
      inquire(file=name,exist=okay)
      end

      function get_tof(d,difc,difa,zero)
      implicit none

      real get_tof,d,difc,difa,zero

      get_tof=difc*d+difa*d*d+zero

      return
      end

      function fwhm_tof2(dp,sigmasq0,sigmasq1,sigmasq2,
     -                     gamma0,gamma1,gamma2)

      implicit none
      real  dp,sigmasq0,sigmasq1,sigmasq2,
     -      gamma0,gamma1,gamma2
      real fwhm_tof2,sigmasq,gamma
      real gau,ggau,ggau2,ggau3,ggau4,ggau5
      real gam2,gam3,gam4,gam5

      sigmasq=max(0.1,(sigmasq0)+(sigmasq1)*dp**2+(sigmasq2)*dp**4)
c     gamma=gamma0+gamma1*dp+(gamma1e*dp+gamma2e*dp**2)*cos(theta)
      gamma=gamma0+gamma1*dp+gamma1*dp**2
      gamma=max(0.0,gamma)

      ggau=sqrt(8*sigmasq*log(2.0))
      ggau2=ggau*ggau
      ggau3=ggau2*ggau
      ggau4=ggau3*ggau
      ggau5=ggau4*ggau
      gam2=gamma*gamma
      gam3=gam2*gamma
      gam4=gam3*gamma
      gam5=gam4*gamma

      gau=(ggau5+2.69269*ggau4*gamma+2.42843*ggau3*gam2+
     -           4.47163*ggau2*gam3+0.07842*ggau*gam4+gam5)**0.2

      fwhm_tof2=gau

      return
      end
